(****************************************************************)
(*                                                              *)
(*       DigPak Interface Unit v0.1 Beta                        *)
(*       Compiler: TMT Pascal 2.11                              *)
(*       Targets:  MS-DOS 32-bit protected mode only            *)
(*                                                              *)
(*       Copyright (c) 1995,98 TMT Development Corporation      *)
(*       Author: Vadim Bodrov                                   *)
(*                                                              *)
(****************************************************************)

(*
                                IMPORTANT NOTICE

    A  $500  per  product  license  fee  applies  to  all commercial software
 products  distributed  with  ANY DIGPAK and another $500 for MIDPAK drivers.
 That's  a  total  of  $1,000  if  your  product  uses BOTH DIGPAK and MIDPAK
 drivers.  If  you  distribute any commercial title with DIGPAK and/or MIDPAK
 drivers  resident  then  this  license fee applies. To pay a license, simply
 write  a  check for $500 for just DIGPAK $500 for just MIDPAK, or $1,000 for
 both  DIGPAK  and MIDPAK single product distribution license payable to: The
 Audio  Solution,  747  Napa  Lane, St. Charles, MO 63304 with a copy of your
 commerical  product.  You  will  receive a signed license agreement from The
 Audio  Solution shortly thereafter. This license fee applies specifically to
 the  inclusion  with  your distribution disk any of the DIGPAK and/or MIDPAK
 drivers.  These drivers are copyrighted works, created by me, to enhance the
 use  of  sound  and music in DOS based commercial software. The license fees
 collected  are  used  to  maintain  the  drivers  and  keep the BBS running.

 WARNING!!!!!!  You  would  be ill-advised to distribute a commercial product
 containing  either  DIGPAK  and/or  MIDPAK  drivers  without having paid the
 distribution  license  fee.  Since  your  product  would  contain unlicensed
 copyrighted software from The Audio Solution, your product could be required
 to be immediately removed from retail distribution. I doubt this is going to
 be  a  problem.  Clearly  if  your  product  is enhanced by the use of these
 drivers,  your  company can easily afford a nominal license fee of $1,000 in
 exchange  for  getting  the use of several man-years of software engineering
 resources.
*)

(***************************************************************************)
(* Used materials:                                                         *)
(* 'TRICKS OF THE GAME-PROGRAMMING GURUS' by Andre LaMothe, John Ratcliff, *)
(* Mark Seminatore, Denise Tyler, Copyright (C) 1994 Sams Publishing       *)
(***************************************************************************)

 unit DigPak;
 {$w-,r-,q-,i-,t-,x+,v-,a+,oa-,opt+}

 interface

 const

(* Sound Mode *)

  PCM_8_MONO=    0000;
  PCM_8_STEREO=  0001;
  PCM_16_MONO=   0002;
  PCM_16_STEREO= 0003;

(* Audio Capabilities *)

  PLAYBACK=      0001;
  MASSAGE=       0002;
  FIXEDFREQ=     0004;
  USESTIMER=     0008;
  SHARESTIMER=   0016;
  LOOPEND=       0032;
  STEREOPAN=     0064;
  STEREOPLAY=    0128;
  AUDIORECORD=   0256;
  DMABACKFILL=   0512;
  PCM16=         1024;
  PCM16STEREO=   2048;

 Type TSndStruct=record
      Sound:     DWord;
      SndLen:    Word;
      IsPlaying: Pointer;
      Frequency: Word;
      Addr:      Pointer;
 end;

 function  SoundStatus: Boolean;
 function  AudioCapabilities: Word;
 procedure StopSound;
 procedure SetAudioHardware (IRQ, BaseAddr, Other: Word);
 procedure WaitSound;
 function  AudioPendingStatus: Byte;
 function  SetStereoPan (Pan: Word): Boolean;
 function  SetPlayMode (Mode: Word): Boolean;
 function  SetAudioVolume (LVolume, RVolume: Word): Boolean;
 function  CheckDMABuffer (Address: Pointer; Size: Word): Boolean;
 function  ReportPendingAddress: Pointer;
 function  ReportSemaphoreAddress: Pointer;
 function  ReportVersionNumber: Word;
 procedure StopNextLoop;
 procedure SetTimerDivisorRate (Rate: Word);
 procedure SetRecordMode (Mode: Word);
 function  SetBackFillMode (Mode: Word): Boolean;
 function  ReportDMAC: Word;
 function  LoadDigPak (fName: String): Boolean;
 function  InitDigPak: Boolean;
 function  DeInitDigPak: Boolean;
 procedure UnLoadDigPak;
 function  SndLoad (Name: String; var SndFile: TSndStruct): Boolean;
 procedure SndFree (var SndFile: TSndStruct);
 procedure DigPlay (var SndPlay: TSndStruct);
 procedure MassageAudio (var SndPlay: TSndStruct);
 procedure DigPlay2 (var SndPlay: TSndStruct);
 function  PostAudioPending (var SndPlay: TSndStruct): Byte;

 implementation

 uses DPMI, MDUtil;

 var HaveDigPak: Boolean := false;
     DigPakLoad: Pointer := nil;
     DigPakSize: LongInt := 0;
     DigPakOn:   Boolean := false;
     DigPakPara: Word    := 0;

     DPMIAddr1:  Pointer;
     RealSEG1:   Word;
     DPMIAddr2:  Pointer;
     RealSEG2:   Word;
     DigPakExit: Pointer;
     Pending:    Word;
     Semaphore:  Word;

 function SoundStatus: Boolean; assembler;
      asm
        mov     ax,$689
        int     $66
 end;

 function AudioCapabilities: Word; assembler;
      asm
        mov     ax,$68C
        int     $66
 end;

 procedure StopSound; assembler;
      asm
        mov     ax,$68F
        int     $66
 end;

 procedure SetAudioHardware(IRQ,BaseAddr,Other: Word); assembler;
      asm
        mov     ax,$690
        mov     bx,[IRQ]
        mov     cx,[BaseAddr]
        mov     dx,[Other]
        int     $66
 end;

 procedure WaitSound; assembler;
      asm
@WS:    mov     ax,$689
        int     $66
        or      ax,ax
        jnz     @WS
 end;

 function AudioPendingStatus: Byte; assembler;
      asm
        mov     ax,$696
        int     $66
 end;

 function SetStereoPan(Pan: Word): Boolean; assembler;
      asm
        mov     dx,[Pan]
        mov     ax,$697
        int     $66
 end;

 function SetPlayMode(Mode: Word): Boolean; assembler;
      asm
        mov     dx,[Mode]
        mov     ax,$698
        int     $66
 end;

 function  SetAudioVolume(LVolume, RVolume: Word): Boolean; assembler;
      asm
        mov     bx,[LVolume]
        mov     cx,[RVolume]
        mov     ax,$69F
        int     $66
 end;

 function  CheckDMABuffer(Address: Pointer; Size: Word): Boolean; assembler;
      asm
        mov     ax,$69E
        xor     bx,bx
        mov     es,[RealSEG1]
        mov     cx,[Size]
        int     $66
 end;

 function ReportPendingAddress: Pointer;
 var Regs: TRmRegs;
 begin
  if Pending=0 then begin
   ClearRmRegs(Regs);
   Regs.AX:=$699;
   RealModeInt($66,Regs);
   Pending:=AllocateDescriptors(1);
   SetSelectorBaseAddress(Pending,DWord(Regs.DX)*16+Regs.AX);
   SetSelectorLimit(Pending,4);
  end;
  ReportPendingAddress:=Ptr(Pending,0);
 end;

 function ReportSemaphoreAddress: Pointer;
 var Regs: TRmRegs;
 begin
  if Semaphore=0 then begin
   ClearRmRegs(Regs);
   Regs.AX:=$699;
   RealModeInt($66,Regs);
   Semaphore:=AllocateDescriptors(1);
   SetSelectorBaseAddress(Semaphore,DWord(Regs.DX)*16+Regs.BX);
   SetSelectorLimit(Semaphore,4);
  end;
  ReportSemaphoreAddress:=Ptr(Semaphore,0);
 end;

 function ReportVersionNumber: Word; assembler;
      asm
        xor     bx,bx
        mov     ax,$689
        int     $66
        mov     ax,bx
 end;

 procedure StopNextLoop; assembler;
      asm
        mov     ax,$69B
        int     $66
 end;

 procedure SetTimerDivisorRate(Rate: Word); assembler;
      asm
        mov     ax,$693
        mov     dx,[Rate]
        int     $66
 end;

 procedure SetRecordMode(Mode: Word); assembler;
      asm
        mov     dx,[Mode]
        mov     ax,$69A
        int     $66
 end;

 function SetBackFillMode(Mode: Word): Boolean; assembler;
      asm
        mov     dx,[Mode]
        mov     ax,$69C
        int     $66
 end;

 function ReportDMAC: Word; assembler;
      asm
        mov     ax,$69D
        int     $66
 end;

 function LoadDigPak(fName: String): Boolean;
 begin
  if HaveDigPak then begin
   LoadDigPak:=false; exit;
  end;
  DigPakSize:=SizeOfFile(fName);
  DigPakPara:=xGlobalDosAlloc(DigPakLoad,DigPakSize+$100);
  if DigPakLoad=nil then begin
   LoadDigPak:=false;
   exit;
  end;
  if ReadFromFile(fName,Pointer(DWord(DigPakLoad)+$100),0,DigPakSize)
  then HaveDigPak:=true else begin
   HaveDigPak:=false;
   DigPakPara:=0;
   xGlobalDosFree(DigPakLoad);
  end;
 end;

 function InitDigPak: Boolean;
 var Regs: TRmRegs;
 begin
  if (HaveDigPak) and (xGetStr(DigPakLoad,$103,6)='DIGPAK') then begin
   ClearRmRegs(Regs);
   Regs.CS:=DigPakPara;
   Regs.IP:=$200;
   CallRealModeFar(Regs);
   DigPakOn:=Regs.AX=0;
  end;
  InitDigPak:=DigPakOn;
 end;

 function DeInitDigPak: Boolean;
 var Regs: TRmRegs;
 begin
  if DigPakOn then begin
   ClearRmRegs(Regs);
   Regs.CS:=DigPakPara;
   Regs.IP:=$203;
   CallRealModeFar(Regs);
   DigPakOn:=false;
   DeInitDigPak:=true;
  end else DeInitDigPak:=false;
 end;

 procedure UnLoadDigPak;
 begin
   if HaveDigPak then begin
   if DigPakOn then DeInitDigPak;
   FreeDosMemoryBlock(DigPakPara);
   DigPakPara:=0;
   DigPakLoad:=nil;
   HaveDigPak:=false;
  end;
 end;

 function SndLoad(Name: String; var SndFile: TSndStruct): Boolean;
 begin
  SndFile.Sound:=0;
  if TestFile(Name) then begin
   SndFile.SndLen:=SizeOfFile(Name);
   SndFile.Sound:=($FFFF and xGlobalDosAlloc(SndFile.Addr,1+SndFile.SndLen)) shl 16;
   if SndFile.Sound=0 then begin
    SndLoad:=false;
    exit;
   end;
   if not ReadFromFile(Name,SndFile.Addr,0,SndFile.SndLen)
   then begin
    xGlobalDOSFree(SndFile.Addr);
    SndFile.Sound:=0;
   end;
  end;
  SndFile.Frequency:=11025;
  SndLoad:=SndFile.Sound<>0;
 end;

 procedure SndFree(var SndFile: TSndStruct);
 begin
  if SndFile.Sound<>0 then begin
   xGlobalDosFree(SndFile.Addr);
   SndFile.Sound:=0;
   SndFile.Addr:=nil;
   SndFile.SndLen:=0;
   SndFile.Frequency:=0;
  end;
 end;

 procedure DigPlay(var SndPlay: TSndStruct);
 var Reg: TRmRegs;
 begin
  if not DigPakOn then Exit;
  Move(SndPlay,DPMIAddr1^,SizeOf(SndPlay));
  ClearRmRegs(Reg);
  Reg.AX:=$688;
  Reg.DS:=RealSEG1;
  Reg.SI:=0;
  RealModeInt($66,Reg);
 end;

 procedure MassageAudio(var SndPlay: TSndStruct);
 var Reg: TRmRegs;
 begin
  if not DigPakOn then Exit;
  Move(SndPlay,DPMIAddr1^,SizeOf(SndPlay));
  ClearRmRegs(Reg);
  Reg.AX:=$68A;
  Reg.DS:=RealSEG1;
  Reg.SI:=0;
  RealModeInt($66,Reg);
 end;

 procedure DigPlay2(var SndPlay: TSndStruct);
 var Reg: TRmRegs;
 begin
  if not DigPakOn then Exit;
  Move(SndPlay,DPMIAddr1^,SizeOf(SndPlay));
  ClearRmRegs(Reg);
  Reg.AX:=$68B;
  Reg.DS:=RealSEG1;
  Reg.SI:=0;
  RealModeInt($66,Reg);
 end;

 function PostAudioPending(var SndPlay: TSndStruct): Byte;
 var Regs: TRmRegs;
 begin
  if not DigPakOn then Exit;
  Move(SndPlay,DPMIAddr2^,SizeOf(SndPlay));
  ClearRmRegs(Regs);
  Regs.AX:=$695;
  Regs.DS:=RealSEG2;
  Regs.SI:=0;
  RealModeInt($66,Regs);
  PostAudioPending:=Regs.AX;
 end;

 procedure ExitDigPak;
 begin
  ExitProc:=DigPakExit;
  xGlobalDOSFree(DPMIAddr1);
  xGlobalDOSFree(DPMIAddr2);
  if Pending<>0 then FreeDescriptor(Pending);
  if Semaphore<>0 then FreeDescriptor(Semaphore);
 end;

begin
  RealSEG1:=xGlobalDOSAlloc(DPMIAddr1,SizeOf(TSndStruct));
  RealSEG2:=xGlobalDOSAlloc(DPMIAddr2,SizeOf(TSndStruct));
  DigPakExit:=ExitProc;
  ExitProc:=@ExitDigPak;
 end.

