(****************************************************************)
(*                                                              *)
(*       Memory/Disk Utility Library for MidPak & DigPak Units  *)
(*       Compiler: TMT Pascal 2.11                              *)
(*       Targets:  MS-DOS 32-bit protected mode only            *)
(*                                                              *)
(*       Copyright (c) 1995,98 TMT Development Corporation      *)
(*       Author: Vadim Bodrov                                   *)
(*                                                              *)
(****************************************************************)

(*
                                IMPORTANT NOTICE

    A  $500  per  product  license  fee  applies  to  all commercial software
 products  distributed  with  ANY DIGPAK and another $500 for MIDPAK drivers.
 That's  a  total  of  $1,000  if  your  product  uses BOTH DIGPAK and MIDPAK
 drivers.  If  you  distribute any commercial title with DIGPAK and/or MIDPAK
 drivers  resident  then  this  license fee applies. To pay a license, simply
 write  a  check for $500 for just DIGPAK $500 for just MIDPAK, or $1,000 for
 both  DIGPAK  and MIDPAK single product distribution license payable to: The
 Audio  Solution,  747  Napa  Lane, St. Charles, MO 63304 with a copy of your
 commerical  product.  You  will  receive a signed license agreement from The
 Audio  Solution shortly thereafter. This license fee applies specifically to
 the  inclusion  with  your distribution disk any of the DIGPAK and/or MIDPAK
 drivers.  These drivers are copyrighted works, created by me, to enhance the
 use  of  sound  and music in DOS based commercial software. The license fees
 collected  are  used  to  maintain  the  drivers  and  keep the BBS running.

 WARNING!!!!!!  You  would  be ill-advised to distribute a commercial product
 containing  either  DIGPAK  and/or  MIDPAK  drivers  without having paid the
 distribution  license  fee.  Since  your  product  would  contain unlicensed
 copyrighted software from The Audio Solution, your product could be required
 to be immediately removed from retail distribution. I doubt this is going to
 be  a  problem.  Clearly  if  your  product  is enhanced by the use of these
 drivers,  your  company can easily afford a nominal license fee of $1,000 in
 exchange  for  getting  the use of several man-years of software engineering
 resources.
*)

(***************************************************************************)
(* Used materials:                                                         *)
(* 'TRICKS OF THE GAME-PROGRAMMING GURUS' by Andre LaMothe, John Ratcliff, *)
(* Mark Seminatore, Denise Tyler, Copyright (C) 1994 Sams Publishing       *)
(***************************************************************************)


 unit MDUtil;
 {$w-,r-,q-,i-,t-,x+,v-,a+,oa-,opt+}

 interface

 uses DPMI;

 type
  LongRec = record
    Lo, Hi: Word;
  end;

 function  SizeOfFile(fName: String): DWord;
 function  xGlobalDosAlloc(var Addr: Pointer; Size: LongInt): Word;
 procedure xGlobalDosFree(var Addr: Pointer);
 function  ReadFromFile(fName: String; Buf: Pointer; fPos,Num: Longint): Boolean;
 function  xGetStr(Addr: Pointer; Offset: LongInt; Len: Byte): String;
 function  TestFile(Name: String): Boolean;
 function  StrToInt(S: String): LongInt;

 implementation

 function SizeOfFile(fName: String): DWord;
 var f: file;
 begin
{$I-}
  Assign(f,fName);
  Reset(f,1);
  Result:=FileSize(f);
  Close(f);
{$I+}
 end;

 function xGlobalDosAlloc(var Addr: Pointer; Size: LongInt): Word;
 var Long: DWord;
 begin
  Long:=AllocDosMemoryBlock(Size);
  Addr:=Pointer(DWord(LongRec(Long).Hi)*16);
  Result:=LongRec(Long).Hi;
 end;

 procedure xGlobalDosFree(var Addr: Pointer);
 begin
  FreeDosMemoryBlock(DWord(Addr) div 16);
 end;

 function ReadFromFile(fName: String; Buf: Pointer; fPos,Num: Longint): Boolean;
 var Offset, Count: Longint;
     F: file;
 begin
{$i-}
  Assign(F,fName);
  Reset(F,1);
{$i+}
  if IOResult<>0 then begin ReadFromFile:=false; exit; end;
{$i-}
  Seek(F,fPos);
  if Buf<>nil then begin
   BlockRead(F,Buf^,Num);
{$i+}
  if IOResult<>0 then begin ReadFromFile:=false; exit; end;
{$i-}
  end;
  Close(F);
 end;

 function xGetStr(Addr: Pointer; Offset: LongInt; Len: Byte): String;
 var S: String;
     i: Byte;
 begin
  S:='';
  Inc(Addr,Offset);
  for i:=1 to Len do begin
   S:=S+Chr(Byte(Addr^));
   Inc(Addr);
  end;
  Result:=S;
 end;

 function TestFile(Name: String): Boolean;
 var f: File;
 begin
{$i-}
  Assign(f,Name);
  Reset(f,1);
{$i+}
  if IOResult=0 then begin
{$i-}
   TestFile:=true;
   Close(f);
  end else TestFile:=false;
 end;

 function StrToInt(S: String): LongInt;
 var Res:     LongInt;
     ErrCode: Longint;
 begin
  Val(S, Res, ErrCode);
  Result := Res;
 end;

 end.